#include "getfile.h"
#include <stdexcept>

using namespace std;

namespace GetStdTextFile
{
	BOOL GetTextFile::LoadFile(HWND hEdit, LPSTR pszFileName)
	{
		HANDLE hFile;
		BOOL bSuccess = FALSE;

		hFile = CreateFileA(pszFileName, GENERIC_READ, FILE_SHARE_READ, NULL,
			OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
		if(hFile != INVALID_HANDLE_VALUE)
		{
			DWORD dwFileSize;
			dwFileSize = GetFileSize(hFile, NULL);
			if(dwFileSize != 0xFFFFFFFF)
			{
			    LPSTR pszFileText;
				pszFileText = LPSTR(GlobalAlloc(GPTR, dwFileSize + 1));
				if(pszFileText != NULL)
				{
					DWORD dwRead;
					if(ReadFile(hFile, pszFileText, dwFileSize, &dwRead, NULL))
					{
						pszFileText[dwFileSize] = 0; // Null terminator
						if(SetWindowTextA(hEdit, pszFileText))
							bSuccess = TRUE; // It worked!
					}
					GlobalFree(pszFileText);
				}
			}
			CloseHandle(hFile);
		}
		return bSuccess;
	}

	BOOL GetTextFile::SaveFile(HWND hEdit, LPSTR pszFileName)
	{
		HANDLE hFile;
		BOOL bSuccess = FALSE;
	
		hFile = CreateFileA(pszFileName, GENERIC_WRITE, 0, NULL,
			CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0);
		if(hFile != INVALID_HANDLE_VALUE)
		{
			DWORD dwTextLength;
			dwTextLength = GetWindowTextLength(hEdit);
			if(dwTextLength > 0)// No need to bother if there's no text.
			{
				LPSTR pszText;
				pszText = LPSTR(GlobalAlloc(GPTR, dwTextLength + 1));
				if(pszText != NULL)
				{
					if(GetWindowTextA(hEdit, pszText, dwTextLength + 1))
					{
						DWORD dwWritten;
						if(WriteFile(hFile, pszText, dwTextLength, &dwWritten, NULL))
							bSuccess = TRUE;
					}
					GlobalFree(pszText);
				}
			}
			CloseHandle(hFile);
		}
		return bSuccess;
	}

	BOOL GetTextFile::GetFileName(HWND hwnd, LPSTR pszFileName, BOOL bSave)
	{
		OPENFILENAMEA ofn;
		
		ZeroMemory(&ofn, sizeof(ofn));
		pszFileName[0] = 0;
		
		ofn.lStructSize = sizeof(ofn);
		ofn.hwndOwner = hwnd;
		ofn.lpstrFile = pszFileName;
		ofn.nMaxFile = MAX_PATH;
		ofn.lpstrDefExt = "*";
		
		if(bSave)
		{
			ofn.Flags = OFN_EXPLORER | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY |
				OFN_OVERWRITEPROMPT;
			ofn.lpstrTitle = "Guardar archivo como...";
			ofn.lpstrFilter = "Text Files (*.txt)\0*.txt\0HTML Document (*.html)\0*.html\0All Files (*.*)\0*.*\0\0";
			if(!GetSaveFileNameA(&ofn))
				return FALSE;
		}
		else
		{
			ofn.Flags = OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
			ofn.lpstrTitle = "Abrir: seleccione el arcivo deseado";
			ofn.lpstrFilter = "All Files (*.*)\0*.*\0Text Files (*.*)\0*.txt\0\0";
			if(!GetOpenFileNameA(&ofn))
				return FALSE;
		}
		return TRUE;
	}
}
