#include "main.hpp"
#include "client.hpp"

HWND hCHdr, hClientName, hClientLastName, hClientID, hClientDocument, 
	hClientPhone, hClientAddress, hwndhelpbutton, hInsertButton;
static HINSTANCE hInstance;

int _stdcall ClientStdProc (HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	RECT rc = {0, 0, 0, 0};

	switch (msg)
	{
		case WM_INITDIALOG:
			{
            #pragma region Header
			hCHdr = CreateWindowExW(0, WC_HEADER, TEXT(""), 
				WS_VISIBLE | WS_CHILD | WS_CLIPSIBLINGS | WS_TABSTOP | HDS_DRAGDROP | HDS_BUTTONS | HDS_HORZ, 
				rc.left + 10, rc.top + 20, rc.right, rc.bottom, hwnd, (HMENU)IDDC_REGCLIENTS, hInstance, NULL);
			SetWindowLongPtr(hwnd, GWLP_USERDATA, (LONG_PTR)hCHdr);
			
			GetClientRect(hwnd, &rc);
			OnHeaderSize(hwnd, 0, rc.right, rc.bottom);
			
			SendMessage(hCHdr, WM_SETFONT, (WPARAM)GetStockObject(DEFAULT_GUI_FONT), 0);
			
			HDITEM hdi;
			hdi.mask = HDI_WIDTH | HDI_FORMAT | HDI_TEXT;
			hdi.cxy = 118;
			hdi.fmt = HDF_CENTER;
			hdi.cchTextMax = 200;
			
			hdi.pszText = L"ID";
			SendMessage(hCHdr, HDM_INSERTITEM, 0, (LPARAM)&hdi);
			hdi.pszText = L"Nombre";
			SendMessage(hCHdr, HDM_INSERTITEM, 1, (LPARAM)&hdi);
			hdi.pszText = L"Apellido";
			SendMessage(hCHdr, HDM_INSERTITEM, 2, (LPARAM)&hdi);
			hdi.pszText = L"Documento";
			SendMessage(hCHdr, HDM_INSERTITEM, 3, (LPARAM)&hdi);
			hdi.pszText = L"Direccin";
			SendMessage(hCHdr, HDM_INSERTITEM, 4, (LPARAM)&hdi);
			hdi.pszText = L"Telfono";
			SendMessage(hCHdr, HDM_INSERTITEM, 5, (LPARAM)&hdi);
			#pragma endregion

			#pragma region ListView
			LVHandles* lvh = new LVHandles();
			SetWindowLongPtr(hwnd, GWLP_USERDATA, (LONG_PTR)lvh);
			GetClientRect(hwnd, &rc);
			lvh->hListview = CreateWindowEx(0, WC_LISTVIEW, 0, 
				LVS_ICON | LVS_LIST | WS_CHILD | WS_VISIBLE, 
				rc.left + 12, rc.top + 48, rc.right - 330, rc.bottom - 310, hwnd, 
				(HMENU)IDC_LISTVIEW, hInstance, 0);

			int lx = GetSystemMetrics(SM_CXICON);
			int ly = GetSystemMetrics(SM_CYICON);
			lvh->hLargeIcons = ImageList_Create(lx, ly, ILC_COLOR32 | ILC_MASK, 1, 1); 
			int sx = GetSystemMetrics(SM_CXSMICON);
			int sy = GetSystemMetrics(SM_CYSMICON);
			lvh->hSmallIcons = ImageList_Create(sx, sy, ILC_COLOR32 | ILC_MASK, 1, 1);

			
			HICON hLargeIcon, hSmallIcon;
			
			hLargeIcon = (HICON)LoadImage(hInstance, MAKEINTRESOURCE(IDI_CONTACT), 
				IMAGE_ICON, lx, ly, 0);
			ImageList_AddIcon(lvh->hLargeIcons, hLargeIcon);
			DestroyIcon(hLargeIcon);

			
			hSmallIcon = (HICON)LoadImage(hInstance, MAKEINTRESOURCE(IDI_CONTACT), 
	            IMAGE_ICON, sx, sy, 0);
			ImageList_AddIcon(lvh->hSmallIcons, hSmallIcon);
			DestroyIcon(hSmallIcon);

			
		    ListView_SetImageList(lvh->hListview, lvh->hLargeIcons, LVSIL_NORMAL); 
			ListView_SetImageList(lvh->hListview, lvh->hSmallIcons, LVSIL_SMALL);


			LVITEM lvi = {0};
			lvi.mask = LVIF_TEXT | LVIF_IMAGE;
			TCHAR szText[200];
			for (int i = 0; i < 10; i++)
			{
				lvi.iItem = i;
				swprintf_s(szText, 200, L"Item  %d", i);
				lvi.pszText = szText;
				lvi.iImage = i;

				SendMessage(lvh->hListview, LVM_INSERTITEM, 0, (LPARAM)&lvi);
			}
			ListView_GetHeader(hCHdr);
			#pragma endregion			
			
			#pragma region Edit&others
			
			hClientName = CreateWindowEx(WS_EX_CLIENTEDGE, WC_EDIT, L"", 
				WS_VISIBLE | WS_CHILD | WS_CLIPSIBLINGS | WS_TABSTOP,
				885, 30, 150, 25, hwnd, NULL, hInstance, NULL);
			hClientLastName = CreateWindowEx(WS_EX_CLIENTEDGE, WC_EDIT, L"", 
				WS_VISIBLE | WS_CHILD | WS_CLIPSIBLINGS | WS_TABSTOP,
				885, 66, 150, 25, hwnd, NULL, hInstance, NULL);
			hClientID = CreateWindowEx(WS_EX_CLIENTEDGE, WC_EDIT, L"", 
				WS_VISIBLE | WS_CHILD | WS_CLIPSIBLINGS | WS_TABSTOP | ES_NUMBER,
				885, 102, 150, 25, hwnd, NULL, hInstance, NULL);
			hClientDocument = CreateWindowEx(WS_EX_CLIENTEDGE, WC_EDIT, L"", 
				WS_VISIBLE | WS_CHILD | WS_CLIPSIBLINGS | WS_TABSTOP,
				885, 138, 150, 25, hwnd, NULL, hInstance, NULL);
			hClientPhone = CreateWindowEx(WS_EX_CLIENTEDGE, WC_EDIT, L"", 
				WS_VISIBLE | WS_CHILD | WS_CLIPSIBLINGS | WS_TABSTOP,
				885, 174, 150, 25, hwnd, NULL, hInstance, NULL);
			hClientAddress = CreateWindowEx(WS_EX_CLIENTEDGE, WC_EDIT, L"", 
				WS_VISIBLE | WS_CHILD | WS_CLIPSIBLINGS | WS_TABSTOP,
				885, 210, 150, 25, hwnd, NULL, hInstance, NULL);
			hInsertButton = CreateWindowEx(0, WC_BUTTON, L"Ingresar",
				WS_VISIBLE | WS_CHILD | BS_COMMANDLINK | WS_TABSTOP,
				758, 265, 130, 57, hwnd, NULL, hInstance, NULL);
			SendMessage(hInsertButton, BCM_SETNOTE, 0, (LPARAM)L"un nuevo cliente");
			HWND hCleanButton = CreateWindowEx(0, WC_BUTTON, L"Limpiar",
				WS_VISIBLE | WS_CHILD | BS_COMMANDLINK | WS_TABSTOP,
				900, 265, 140, 57, hwnd, (HMENU)IDC_CLEANALLFIELDS, hInstance, NULL);
			SendMessage(hCleanButton, BCM_SETNOTE, 0, (LPARAM)L"todos los campos");
			HWND hGroup1 = CreateWindowExW(0, WC_BUTTON, L"Clientes Registrados", 
				WS_VISIBLE | WS_CHILD | WS_CLIPSIBLINGS | BS_GROUPBOX, 5, 5, 
				735, 325, hwnd, NULL, hInstance, NULL);
			HWND hGroup2 = CreateWindowExW(0, WC_BUTTON, L"Aadir Cliente", 
				WS_VISIBLE | WS_CHILD | WS_CLIPSIBLINGS | BS_GROUPBOX, 745, 5, 
				300, 325, hwnd, NULL, hInstance, NULL);
			HWND hGroup3 = CreateWindowExW(0, WC_BUTTON, L"Administrar existentes", 
				WS_VISIBLE | WS_CHILD | WS_CLIPSIBLINGS | BS_GROUPBOX, 5, 330, 
				735, 227, hwnd, NULL, hInstance, NULL);
			#pragma endregion
			}
			return TRUE;
		case WM_CONTEXTMENU:
			{
				HMENU hmenu = LoadMenu(hInstance, MAKEINTRESOURCE(IDM_SECMENU));
				TrackPopupMenuEx(GetSubMenu(hmenu, 0), TPM_CENTERALIGN | TPM_HORIZONTAL | 
					TPM_RIGHTBUTTON, LOWORD(lParam), HIWORD(lParam), hwnd, NULL);
			}
			return TRUE;
		case WM_COMMAND:
			switch (LOWORD(wParam))
			{
			    case IDC_CLEANALLFIELDS:
					SendMessage(hClientName, WM_SETTEXT, 0, (LPARAM)L"");
					SendMessage(hClientLastName, WM_SETTEXT, 0, (LPARAM)L"");
					SendMessage(hClientID, WM_SETTEXT, 0, (LPARAM)L"");
					SendMessage(hClientDocument, WM_SETTEXT, 0, (LPARAM)L"");
					SendMessage(hClientPhone, WM_SETTEXT, 0, (LPARAM)L"");
					SendMessage(hClientAddress, WM_SETTEXT, 0, (LPARAM)L"");
					break;
				case IDOK:
					EndDialog(hwnd, 0);
					break;
				case IDHELP:
					MessageBox(hwnd, L"No hay ayuda disponible.\n", L"", MB_OK | MB_ICONWARNING);
					break;
				case IDDC_CLOSEDLG:
				case IDCANCEL:
					EndDialog(hwnd, 0);
					break;
			}
			return TRUE;
		case WM_SIZE:
			{
				int cx = 200, cy = 100;
				LVHandles* lvh = (LVHandles*)GetWindowLongPtr(hwnd, GWLP_USERDATA);
				SendMessage(lvh->hListview, LVM_ARRANGE, LVA_ALIGNTOP, 0);
			}
			return TRUE;
		case WM_CLOSE:
			{
				LVHandles* lvh = (LVHandles*)GetWindowLongPtr(hwnd, GWLP_USERDATA);
				ImageList_Destroy(lvh->hLargeIcons);
				ImageList_Destroy(lvh->hSmallIcons);
				delete lvh;

				DestroyWindow(hwnd);
			}
			return TRUE;
		case WM_DESTROY:
			EndDialog(hwnd, 0);
			return TRUE;
	}
	return FALSE;
}

void OnHeaderSize(HWND hwnd, UINT state, int cx, int cy)
{
    RECT rc = { 0, 0, cx, cy };
    WINDOWPOS wp = { 0 };
    HDLAYOUT hdl = { &rc, &wp };
	HWND hCHdr = (HWND)GetWindowLongPtr(hwnd, GWLP_USERDATA);

	SendMessage(hCHdr, HDM_LAYOUT, 0, (LPARAM)&hdl);

	SetWindowPos(hCHdr, wp.hwndInsertAfter, 
        wp.x + 10, wp.y + 20, wp.cx -325, wp.cy + 5, wp.flags);
}


