#define _WIN32_WINNT 0x0600
#define _WIN32_IE 0x0700 
#include <windows.h>
#include <commctrl.h>
#include "main.hpp"

HINSTANCE g_hInst;
TCHAR tszClassName [] = TEXT("AppClassName");
HWND hMainWindow, hQueryButton, hPayButton, hClientsButton, hProductsButton, hDistButton;

int _stdcall wWinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, LPWSTR lpCmdLine, int nShowCmd)
{
	WNDCLASSEX wcex;
	MSG message;
	INITCOMMONCONTROLSEX iccex = {sizeof (INITCOMMONCONTROLSEX), ICC_LISTVIEW_CLASSES};
	if (!InitCommonControlsEx(&iccex))
		return 0;
	HRESULT hr = CoInitializeEx(NULL, COINIT_APARTMENTTHREADED | COINIT_DISABLE_OLE1DDE);
	if (FAILED(hr))
	{
		// Handle the error.
	}
	else
	{
	    // The function succeeded.
	}

	UNREFERENCED_PARAMETER(hPrevInstance);
	g_hInst = hInstance; // g_hInst gets hInstance value

	wcex.cbClsExtra = 0;
	wcex.cbSize = sizeof(WNDCLASSEX);
	wcex.cbWndExtra = 0;
	wcex.hbrBackground = (HBRUSH)COLOR_GRADIENTINACTIVECAPTION;
	wcex.hCursor = LoadCursorW(hInstance, IDC_ARROW);
	wcex.hIcon = LoadIconW(hInstance, MAKEINTRESOURCE(IDI_LOGO));
	wcex.hIconSm = LoadIconW(hInstance, MAKEINTRESOURCE(IDI_LOGO));
	wcex.hInstance = hInstance;
	wcex.lpfnWndProc = WindowProcedure;
	wcex.lpszClassName = tszClassName;
	wcex.lpszMenuName = NULL;
	wcex.style = CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW;

	if (!RegisterClassExW(&wcex)) {
		return 0;
	}

	hMainWindow = CreateWindowExW (WS_EX_CLIENTEDGE | WS_EX_APPWINDOW, tszClassName,
		TEXT("Infomarket 1.0.0"), WS_OVERLAPPEDWINDOW, 5, 5,
		800, 600, HWND_DESKTOP, NULL, hInstance, NULL);
	if (!hMainWindow) {
		MessageBoxW(0, TEXT("Error!\nMain Window cannot be created."), TEXT(""), 
			MB_OK | MB_ICONSTOP);
		return 0;
	}
	AddMenu(hMainWindow);
	ShowWindow (hMainWindow, SW_SHOWDEFAULT);

	while (TRUE == GetMessage(&message, 0, 0, 0))
	{
		TranslateMessage (&message);
		DispatchMessage (&message);
	}
	CoUninitialize();
	return message.wParam;
}

LRESULT _stdcall WindowProcedure (HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	HDC hDC;
	PAINTSTRUCT ps;
	COLORREF color = 0x00000000; // black
	POINT point;
	HPEN hpen1;
	static HBITMAP bitmap, bitmap2;
	HFONT hclientfont = CreateFont(19, 0, 0, 0, FW_MEDIUM, FALSE, FALSE, FALSE, 
		DEFAULT_CHARSET, OUT_TT_PRECIS, CLIP_DEFAULT_PRECIS, PROOF_QUALITY, 
		DEFAULT_PITCH | FF_ROMAN, L"Candara");
	HFONT hgroupfont = CreateFont(12, 0, 0, 0, FW_MEDIUM, FALSE, FALSE, FALSE, 
		DEFAULT_CHARSET, OUT_TT_PRECIS, CLIP_DEFAULT_PRECIS, PROOF_QUALITY, 
		DEFAULT_PITCH | FF_ROMAN, L"Calibri");
	static HWND hqueriesgroup, hdbgroup, hwndlogo, hwndearth;
	static HMENU hSecMenu  = LoadMenu(g_hInst, MAKEINTRESOURCE(IDM_SECMENU));
	static HINSTANCE hInstance;

	switch (msg)
	{
	    case WM_CREATE:
		{
			hInstance = ((LPCREATESTRUCT)lParam)->hInstance;
			RECT rc = {0, 0, 520, 400};
			GetWindowRect(hMainWindow, &rc);
			// main buttons in workspace
			hQueryButton = CreateWindowExW(0, WC_BUTTON, TEXT("&Consultas"), 
				WS_VISIBLE | WS_CHILD | WS_CLIPSIBLINGS | WS_TABSTOP,
				rc.left +50, rc.top + 50, 150, 60, hwnd, (HMENU)IDC_QUERY, g_hInst, NULL);
			hPayButton = CreateWindowExW(0, WC_BUTTON, TEXT("&Pagos"), 
				WS_VISIBLE | WS_CHILD | WS_CLIPSIBLINGS | WS_TABSTOP,
				rc.left +50, rc.top + 125, 150, 60, hwnd, (HMENU)IDC_PAY, g_hInst, NULL);
			hClientsButton = CreateWindowExW(0, WC_BUTTON, TEXT("C&lientes"), 
				WS_VISIBLE | WS_CHILD | WS_CLIPSIBLINGS | WS_TABSTOP,
				rc.left +50, rc.top + 230, 150, 60, hwnd, (HMENU)IDC_CLIENTS, g_hInst, NULL);
			hProductsButton = CreateWindowExW(0, WC_BUTTON, TEXT("Pro&ductos"), 
				WS_VISIBLE | WS_CHILD | WS_CLIPSIBLINGS | WS_TABSTOP,
				rc.left +50, rc.top + 305, 150, 60, hwnd, (HMENU)IDC_PRODUCTS, g_hInst, NULL);
			hDistButton = CreateWindowExW(0, WC_BUTTON, TEXT("Pro&veedores"), 
				WS_VISIBLE | WS_CHILD | WS_CLIPSIBLINGS | WS_TABSTOP,
				rc.left +50, rc.top + 380, 150, 60, hwnd, (HMENU)IDC_DIST, g_hInst, NULL);
			// groups of buttons, according to their categories
            hqueriesgroup = CreateWindowExW(0, WC_BUTTON, TEXT("Consultas"), 
				WS_VISIBLE | WS_CHILD | WS_CLIPSIBLINGS | WS_TABSTOP | BS_GROUPBOX,
				rc.left + 40, rc.top + 30, 170, 170, hwnd, NULL, g_hInst, NULL);
			hdbgroup = CreateWindowExW(0, WC_BUTTON, TEXT("Bases de Datos"), 
				WS_VISIBLE | WS_CHILD | WS_CLIPSIBLINGS | WS_TABSTOP | BS_GROUPBOX,
				rc.left + 40, rc.top + 210, 170, 245, hwnd, NULL, g_hInst, NULL);
			// send the WM_SETFONT message to change text appearance
			SendMessage(hQueryButton, WM_SETFONT, (WPARAM)hclientfont, TRUE);
			SendMessage(hPayButton, WM_SETFONT, (WPARAM)hclientfont, TRUE);
			SendMessage(hClientsButton, WM_SETFONT, (WPARAM)hclientfont, TRUE);
			SendMessage(hProductsButton, WM_SETFONT, (WPARAM)hclientfont, TRUE);
			SendMessage(hDistButton, WM_SETFONT, (WPARAM)hclientfont, TRUE);
			SendMessage(hqueriesgroup, WM_SETFONT, (WPARAM)hgroupfont, TRUE);
			SendMessage(hdbgroup, WM_SETFONT, (WPARAM)hgroupfont, TRUE);
			bitmap = LoadBitmapW(hInstance, MAKEINTRESOURCE(IDB_EARTH));
			hwndearth = CreateWindowExW(0, WC_STATIC, TEXT("logo"), WS_VISIBLE | WS_CHILD |
				WS_CLIPSIBLINGS | SS_NOTIFY | SS_BITMAP, 240, 390, 48, 48, hwnd, NULL, hInstance, NULL);
			SendMessage(hwndearth, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)bitmap);
			bitmap2 = LoadBitmapW(hInstance, MAKEINTRESOURCE(IDB_FAKELOGO));
			hwndlogo = CreateWindowExW(0, WC_STATIC, TEXT("fakelogo"), WS_VISIBLE | WS_CHILD |
				WS_CLIPSIBLINGS | SS_NOTIFY | SS_BITMAP, 300, 38, 128, 128, hwnd, NULL, hInstance, NULL);
			SendMessage(hwndlogo, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)bitmap2);
			HWND hstatic = CreateWindowExW(0, WC_STATIC, 
				L"(c) 2012. Infomarket 1.0.0 es-ES.\n", 
				WS_VISIBLE | WS_CHILD |	WS_CLIPSIBLINGS, 
				300, 390, 440, 48, hwnd, NULL, hInstance, NULL);
			SendMessage(hstatic, WM_SETFONT, (WPARAM)hgroupfont, TRUE);
		}
			break;
		case WM_PAINT:
			hDC = BeginPaint(hwnd, &ps);
			hpen1 = CreatePen(PS_SOLID, 15, color);
			MoveToEx(hDC, 220, 35, &point);
			LineTo(hDC, 220, 455);
			MoveToEx(hDC, 220, 375, &point);
			LineTo(hDC, 740, 375);
			DeleteObject(hpen1);
			EndPaint(hwnd, &ps);
			break;
		case WM_CONTEXTMENU:
			TrackPopupMenuEx(GetSubMenu(hSecMenu, 0), TPM_CENTERALIGN | TPM_HORIZONTAL | TPM_RIGHTBUTTON, 
				LOWORD(lParam), HIWORD(lParam), hwnd, NULL);
			break;
	    case WM_COMMAND:
			switch (LOWORD (wParam))
			{
			    case IDC_QUERY:
					DialogBoxParam(g_hInst, MAKEINTRESOURCE(IDD_QUERY), hwnd, ConDlgStdProc, 0);
					break;
				case IDC_PAY:
					MessageBoxW(hwnd, TEXT("no disponible"), TEXT(""), MB_OK | MB_ICONINFORMATION);
					break;
				case IDC_CLIENTS:
					DialogBoxParam(g_hInst, MAKEINTRESOURCE(IDD_CLIENT), hwnd, ClientStdProc, 0);
					break;
				case IDC_PRODUCTS:
					MessageBoxW(hwnd, TEXT("no disponible"), TEXT(""), MB_OK | MB_ICONINFORMATION);
					break;
				case IDC_DIST:
					MessageBoxW(hwnd, TEXT("no disponible"), TEXT(""), MB_OK | MB_ICONINFORMATION);
					break;
			    case CM_CONTACT:
					ContactInfo (hMainWindow);
					break;
			    case CM_QUIT:
				{
					int sel_opt = MessageBoxW(hwnd, L"Desea salir del programa\?", 
						L"Confirmar salida", MB_YESNO);
					if (IDYES == sel_opt){
						PostMessage(hwnd, WM_DESTROY, 0, 0);
					}
				}
					break;
				case CM_ABOUT:
					DialogBoxW(g_hInst, MAKEINTRESOURCE(IDD_ABOUT), hwnd, AboutDlgProc);
					break;
			}
			break;
		case WM_HELP:
			MessageBox(hwnd, L"No hay ayuda disponible.\n", L"", MB_OK | MB_ICONWARNING);
			break;
	    case WM_DESTROY:
			DeleteObject(hclientfont);
			DeleteObject(bitmap);
			DeleteObject(hgroupfont);
			DestroyMenu(hSecMenu);
			DeleteObject(hwndlogo);
			PostQuitMessage(0);
			break;
		default:
			return DefWindowProc(hwnd, msg, wParam, lParam);
	}
	return 0;
}

void AddMenu(HWND hMainWindow)
{
	HMENU hmenubar, hmenu1, hmenu2, hmenu2a, hmenu3;
	hmenubar = CreateMenu();
	hmenu1 = CreateMenu();
	hmenu2 = CreateMenu();
	hmenu2a = CreateMenu();
	hmenu3 = CreateMenu();

	AppendMenu(hmenubar, MF_POPUP | MF_STRING, (UINT)hmenu1, TEXT("&Inicio"));
	AppendMenu(hmenubar, MF_POPUP | MF_STRING, (UINT)hmenu2, TEXT("&Base de Datos"));
	AppendMenu(hmenubar, MF_POPUP | MF_STRING, (UINT)hmenu3, TEXT("In&formacin"));

	AppendMenu(hmenu1, MF_STRING, IDC_QUERY, TEXT("Consultas..."));
	AppendMenu(hmenu1, MF_STRING, IDC_PAY, TEXT("Pagos..."));
	AppendMenu(hmenu1, MF_STRING, 0, TEXT("Cerrar Caja"));
	AppendMenu(hmenu1, MF_SEPARATOR, 0, NULL);
	AppendMenu(hmenu1, MF_STRING | MF_POPUP, (UINT)hmenu2a, TEXT("Cierre de Caja"));
	AppendMenu(hmenu2a, MF_STRING, 0, TEXT("Activado"));
	AppendMenu(hmenu2a, MF_STRING, 0, TEXT("Desactivado"));
	AppendMenu(hmenu1, MF_SEPARATOR, 0, NULL);
	AppendMenu(hmenu1, MF_STRING, CM_QUIT, TEXT("&Salir\tAlt+F4"));

	AppendMenu(hmenu2, MF_STRING, IDC_PRODUCTS, TEXT("Catlogo de Productos"));
	AppendMenu(hmenu2, MF_STRING, IDC_CLIENTS, TEXT("Cartera de Clientes"));
	AppendMenu(hmenu2, MF_STRING, IDC_DIST, TEXT("Proveedores"));
	AppendMenu(hmenu2, MF_SEPARATOR, 0, NULL);
	AppendMenu(hmenu2, MF_STRING, 0, TEXT("Copia de Seguridad..."));

	AppendMenu(hmenu3, MF_STRING, CM_ABOUT, TEXT("&Acerca de..."));
	AppendMenu(hmenu3, MF_STRING, CM_CONTACT, TEXT("&Contacto"));

	SetMenu(hMainWindow, hmenubar);
}

